Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3726)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3727)
@@ -615,249 +632,639 @@
                surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-               surfaces%points(3,surfaces%npoints) = zw(k-1)
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k-1)
-               ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k)
-               ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
-               IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k-1)
-               ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k)
-               ENDIF
+               surfaces%points(3,surfaces%npoints) = zw(k)
             ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
+            IF ( point_index(k,j,i+1) < 0 )  THEN
                surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = point_index_count
-               point_index_count    = point_index_count + 1
-               surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-               surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
+               point_index(k,j,i+1) = point_index_count
+               point_index_count    = point_index_count + 1 
+               surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+               surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+               surfaces%points(3,surfaces%npoints) = zw(k)
+            ENDIF
+            IF ( point_index(k,j+1,i+1) < 0 )  THEN
+               surfaces%npoints       = surfaces%npoints + 1    
+               point_index(k,j+1,i+1) = point_index_count
+               point_index_count      = point_index_count + 1 
+               surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+               surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+               surfaces%points(3,surfaces%npoints) = zw(k)
+            ENDIF
+            IF ( point_index(k,j+1,i) < 0 )  THEN
+               surfaces%npoints     = surfaces%npoints + 1    
+               point_index(k,j+1,i) = point_index_count
+               point_index_count    = point_index_count + 1 
+               surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+               surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
                surfaces%points(3,surfaces%npoints) = zw(k)
             ENDIF
             
-            npg = npg + 1            
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-               surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
-            ELSE
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j+1,i)
-               surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)
-            ENDIF
-            
+            npg                        = npg + 1
+            surfaces%polygons(1,npg)   = 4
+            surfaces%polygons(2,npg)   = point_index(k,j,i)
+            surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+            surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
+            surfaces%polygons(5,npg)   = point_index(k,j+1,i)    
          ENDDO
 
-         DO  m = 1, surf_lsm_v(l)%ns
-            i = surf_lsm_v(l)%i(m) + MERGE( surf_lsm_v(l)%ioff, 0, l == 3 )
-            j = surf_lsm_v(l)%j(m) + MERGE( surf_lsm_v(l)%joff, 0, l == 1 )
-            k = surf_lsm_v(l)%k(m) + surf_lsm_v(l)%koff
-!
-!--         Lower left /front vertex
-            IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
-               point_index(k,j,i) = point_index_count
-               point_index_count  = point_index_count + 1
-               surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-               surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-               surfaces%points(3,surfaces%npoints) = zw(k-1)
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+         DO  l = 0, 3
+            DO  m = 1, surf_def_v(l)%ns
+!        
+!--            Determine the indices of the respective grid cell inside the topography.
+!--            Please note, j-index for north-facing surfaces ( l==0 ) is 
+!--            identical to the reference j-index outside the grid box. 
+!--            Equivalent for east-facing surfaces and i-index.
+               i = surf_def_v(l)%i(m) + MERGE( surf_def_v(l)%ioff, 0, l == 3 )
+               j = surf_def_v(l)%j(m) + MERGE( surf_def_v(l)%joff, 0, l == 1 )
+               k = surf_def_v(l)%k(m) + surf_def_v(l)%koff
+!        
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = point_index_count
+                  point_index_count  = point_index_count + 1 
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k-1)
                ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+!        
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+!        
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+               ENDIF
+!        
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = point_index_count
+                  point_index_count    = point_index_count + 1
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k)
                ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
-               IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+               
+               npg = npg + 1            
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
+               ELSE
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j+1,i)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)
+               ENDIF
+               
+            ENDDO
+         
+            DO  m = 1, surf_lsm_v(l)%ns
+               i = surf_lsm_v(l)%i(m) + MERGE( surf_lsm_v(l)%ioff, 0, l == 3 )
+               j = surf_lsm_v(l)%j(m) + MERGE( surf_lsm_v(l)%joff, 0, l == 1 )
+               k = surf_lsm_v(l)%k(m) + surf_lsm_v(l)%koff
+!        
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = point_index_count
+                  point_index_count  = point_index_count + 1
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k-1)
                ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+!        
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+!        
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+               ENDIF
+!        
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = point_index_count
+                  point_index_count    = point_index_count + 1
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k)
                ENDIF
-            ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = point_index_count
-               point_index_count    = point_index_count + 1
-               surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-               surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-               surfaces%points(3,surfaces%npoints) = zw(k)
-            ENDIF
-            
-            npg = npg + 1            
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-               surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
-            ELSE
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j+1,i)
-               surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)
-            ENDIF
-         ENDDO
-         DO  m = 1, surf_usm_v(l)%ns
-            i = surf_usm_v(l)%i(m) + MERGE( surf_usm_v(l)%ioff, 0, l == 3 )
-            j = surf_usm_v(l)%j(m) + MERGE( surf_usm_v(l)%joff, 0, l == 1 )
-            k = surf_usm_v(l)%k(m) + surf_usm_v(l)%koff
-!
-!--         Lower left /front vertex
-            IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
-               point_index(k,j,i) = point_index_count
-               point_index_count  = point_index_count + 1
-               surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-               surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-               surfaces%points(3,surfaces%npoints) = zw(k-1)
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+               
+               npg = npg + 1            
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
+               ELSE
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j+1,i)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)
+               ENDIF
+            ENDDO
+            DO  m = 1, surf_usm_v(l)%ns
+               i = surf_usm_v(l)%i(m) + MERGE( surf_usm_v(l)%ioff, 0, l == 3 )
+               j = surf_usm_v(l)%j(m) + MERGE( surf_usm_v(l)%joff, 0, l == 1 )
+               k = surf_usm_v(l)%k(m) + surf_usm_v(l)%koff
+!        
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = point_index_count
+                  point_index_count  = point_index_count + 1
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k-1)
                ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+!        
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+!        
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = point_index_count
+                     point_index_count    = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k-1)
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = point_index_count
+                     point_index_count      = point_index_count + 1
+                     surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                     surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                     surfaces%points(3,surfaces%npoints) = zw(k)
+                  ENDIF
+               ENDIF
+!        
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = point_index_count
+                  point_index_count    = point_index_count + 1
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k)
                ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
-               IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = point_index_count
-                  point_index_count    = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k-1)
-               ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = point_index_count
-                  point_index_count      = point_index_count + 1
-                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-                  surfaces%points(3,surfaces%npoints) = zw(k)
-               ENDIF
-            ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = point_index_count
-               point_index_count    = point_index_count + 1
-               surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-               surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-               surfaces%points(3,surfaces%npoints) = zw(k)
-            ENDIF
-            
-            npg = npg + 1            
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-               surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
-            ELSE
-               surfaces%polygons(1,npg)   = 4
-               surfaces%polygons(2,npg)   = point_index(k,j,i)
-               surfaces%polygons(3,npg)   = point_index(k,j+1,i)
-               surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
-               surfaces%polygons(5,npg)   = point_index(k+1,j,i)
-            ENDIF
+               
+               npg = npg + 1            
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j,i+1)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)  
+               ELSE
+                  surfaces%polygons(1,npg)   = 4
+                  surfaces%polygons(2,npg)   = point_index(k,j,i)
+                  surfaces%polygons(3,npg)   = point_index(k,j+1,i)
+                  surfaces%polygons(4,npg)   = point_index(k+1,j+1,i)
+                  surfaces%polygons(5,npg)   = point_index(k+1,j,i)
+               ENDIF
+            ENDDO
+         
          ENDDO
-
-      ENDDO
-!
-!--   Deallocate temporary dummy variable
-      DEALLOCATE ( point_index )
-!
-!--   Sum-up total number of surface elements and vertices on domain. This
-!--   will be needed for post-processing. 
-      surfaces%npoints_total = 0
+!        
+!--      Deallocate temporary dummy variable
+         DEALLOCATE ( point_index )
+!
+!--      Sum-up total number of vertices on domain. This
+!--      will be needed for post-processing. 
+         surfaces%npoints_total = 0
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( surfaces%npoints, surfaces%npoints_total, 1,        &
-                           MPI_INTEGER, MPI_SUM, comm2d, ierr )
-       CALL MPI_ALLREDUCE( surfaces%ns, surfaces%ns_total, 1,                  &
-                           MPI_INTEGER, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( surfaces%npoints, surfaces%npoints_total, 1,     &
+                              MPI_INTEGER, MPI_SUM, comm2d, ierr )
 #else
-       surfaces%npoints_total = surfaces%npoints
-       surfaces%ns_total      = surfaces%ns
+          surfaces%npoints_total = surfaces%npoints
 #endif
+       ENDIF
+!
+!--    If output to netcdf is enabled, set-up the coordinate arrays that 
+!--    unambiguously describe the position and orientation of each surface 
+!--    element. 
+       IF ( to_netcdf )  THEN
+!
+!--       Allocate local coordinate arrays
+          ALLOCATE( surfaces%s(1:surfaces%ns)       )
+          ALLOCATE( surfaces%xs(1:surfaces%ns)      )
+          ALLOCATE( surfaces%ys(1:surfaces%ns)      )
+          ALLOCATE( surfaces%zs(1:surfaces%ns)      )
+          ALLOCATE( surfaces%azimuth(1:surfaces%ns) )
+          ALLOCATE( surfaces%zenith(1:surfaces%ns)  )
+          ALLOCATE( surfaces%es_utm(1:surfaces%ns)  )
+          ALLOCATE( surfaces%ns_utm(1:surfaces%ns)  )
+!
+!--       Gather the number of surface on each processor, in order to number
+!--       the surface elements in ascending order with respect to the total 
+!--       number of surfaces in the domain.
+#if defined( __parallel )
+          CALL MPI_ALLGATHER( surfaces%ns, 1, MPI_INTEGER,                     &
+                              num_surfaces_on_pe, 1, MPI_INTEGER, comm2d, ierr  )
+#else
+          num_surfaces_on_pe = surfaces%ns
+#endif
+!
+!--       First, however, determine the offset where couting of the surfaces 
+!--       should start (the sum of surfaces on all PE's with lower MPI rank).
+          i           = 0
+          start_count = 1
+          DO WHILE ( i < myid  .AND.  i <= SIZE( num_surfaces_on_pe ) )
+             start_count = start_count + num_surfaces_on_pe(i)
+             i           = i + 1
+          ENDDO
+!       
+!--       Set coordinate arrays. For horizontal surfaces, azimuth 
+!--       angles are not defined (fill value). Zenith angle is 0 (180) for 
+!--       upward (downward)-facing surfaces.
+          i  = start_count
+          mm = 1
+          DO  m = 1, surf_def_h(0)%ns
+             surfaces%s(mm)       = i
+             surfaces%xs(mm)      = ( surf_def_h(0)%i(m) + 0.5_wp ) * dx
+             surfaces%ys(mm)      = ( surf_def_h(0)%j(m) + 0.5_wp ) * dy
+             surfaces%zs(mm)      = zw(surf_def_h(0)%k(m)+surf_def_h(0)%koff)
+             surfaces%azimuth(mm) = surfaces%fillvalue
+             surfaces%zenith(mm)  = 0.0
+             i                    = i + 1
+             mm                   = mm + 1
+          ENDDO
+          DO  m = 1, surf_lsm_h%ns
+             surfaces%s(mm)       = i
+             surfaces%xs(mm)      = ( surf_lsm_h%i(m) + 0.5_wp ) * dx
+             surfaces%ys(mm)      = ( surf_lsm_h%j(m) + 0.5_wp ) * dy
+             surfaces%zs(mm)      = zw(surf_lsm_h%k(m)+surf_lsm_h%koff)
+             surfaces%azimuth(mm) = surfaces%fillvalue
+             surfaces%zenith(mm)  = 0.0
+             i                    = i + 1
+             mm                   = mm + 1
+          ENDDO
+          DO  m = 1, surf_usm_h%ns
+             surfaces%s(mm)       = i
+             surfaces%xs(mm)      = ( surf_usm_h%i(m) + 0.5_wp ) * dx
+             surfaces%ys(mm)      = ( surf_usm_h%j(m) + 0.5_wp ) * dy
+             surfaces%zs(mm)      = zw(surf_usm_h%k(m)+surf_usm_h%koff)
+             surfaces%azimuth(mm) = surfaces%fillvalue
+             surfaces%zenith(mm)  = 0.0
+             i                    = i + 1
+             mm                   = mm + 1
+          ENDDO
+          DO  m = 1, surf_def_h(1)%ns
+             surfaces%s(mm)       = i
+             surfaces%xs(mm)      = ( surf_def_h(1)%i(m) + 0.5_wp ) * dx
+             surfaces%ys(mm)      = ( surf_def_h(1)%j(m) + 0.5_wp ) * dy
+             surfaces%zs(mm)      = zw(surf_def_h(1)%k(m)+surf_def_h(1)%koff)
+             surfaces%azimuth(mm) = surfaces%fillvalue
+             surfaces%zenith(mm)  = 180.0
+             i                    = i + 1
+             mm                   = mm + 1
+          ENDDO
+!       
+!--       For vertical surfaces, zenith angles are not defined (fill value).  
+!--       Azimuth angle: eastward (0), westward (180), northward (270), 
+!--       southward (90). 
+          DO  l = 0, 3
+             IF ( l == 0 )  THEN
+                az    = 270.0_wp
+                off_x =   0.0_wp
+                off_y = - 0.5_wp
+             ELSEIF ( l == 1 )  THEN
+                az    = 90.0_wp
+                off_x =  0.0_wp
+                off_y =  0.5_wp
+             ELSEIF ( l == 2 )  THEN
+                az    =   0.0_wp
+                off_x = - 0.5_wp
+                off_y =   0.0_wp
+             ELSEIF ( l == 3 )  THEN
+                az   = 180.0_wp
+                off_x =  0.5_wp
+                off_y =  0.0_wp
+             ENDIF
+                
+             DO  m = 1, surf_def_v(l)%ns
+                surfaces%s(mm)       = i
+                surfaces%xs(mm)      = ( surf_def_v(l)%i(m) + off_x ) * dx
+                surfaces%ys(mm)      = ( surf_def_v(l)%j(m) + off_y ) * dy
+                surfaces%zs(mm)      = zu(surf_def_v(l)%k(m))
+                surfaces%azimuth(mm) = az
+                surfaces%zenith(mm)  = surfaces%fillvalue
+                i                    = i + 1
+                mm                   = mm + 1
+             ENDDO
+             DO  m = 1, surf_lsm_v(l)%ns
+                surfaces%s(mm)       = i
+                surfaces%xs(mm)      = ( surf_lsm_v(l)%i(m) + off_x ) * dx
+                surfaces%ys(mm)      = ( surf_lsm_v(l)%j(m) + off_y ) * dy
+                surfaces%zs(mm)      = zu(surf_lsm_v(l)%k(m))
+                surfaces%azimuth(mm) = az
+                surfaces%zenith(mm)  = surfaces%fillvalue
+                i                    = i + 1
+                mm                   = mm + 1
+             ENDDO
+             DO  m = 1, surf_usm_v(l)%ns
+                surfaces%s(mm)       = i
+                surfaces%xs(mm)      = ( surf_usm_v(l)%i(m) + off_x ) * dx
+                surfaces%ys(mm)      = ( surf_usm_v(l)%j(m) + off_y ) * dy
+                surfaces%zs(mm)      = zu(surf_usm_v(l)%k(m))
+                surfaces%azimuth(mm) = az
+                surfaces%zenith(mm)  = surfaces%fillvalue
+                i                    = i + 1
+                mm                   = mm + 1
+             ENDDO
+          ENDDO
+!       
+!--       Finally, define UTM coordinates, which are the x/y-coordinates 
+!--       plus the origin (lower-left coordinate of the model domain).
+          surfaces%es_utm = surfaces%xs + init_model%origin_x 
+          surfaces%ns_utm = surfaces%ys + init_model%origin_y 
+!
+!--       Initialize NetCDF data output. Please note, local start position for 
+!--       the surface elements in the NetCDF file is surfaces%s(1), while 
+!--       the number of surfaces on the subdomain is given by surfaces%ns.
+#if defined( __netcdf4_parallel )
+
+!
+!--       Calculate number of time steps to be output
+          ntdim_surf(0) = dosurf_time_count(0) + CEILING(                            &
+                        ( end_time - MAX(                                            &
+                            MERGE(skip_time_dosurf, skip_time_dosurf + spinup_time,  &
+                                  data_output_during_spinup ),                       &
+                            simulated_time_at_begin )                                &
+                        ) / dt_dosurf )
+
+          ntdim_surf(1) = dosurf_time_count(1) + CEILING(                      &
+                        ( end_time - MAX(                                      &
+                            MERGE(   skip_time_dosurf_av, skip_time_dosurf_av  &
+                                  + spinup_time, data_output_during_spinup ),  &
+                            simulated_time_at_begin )                          &
+                        ) / dt_dosurf_av )
+
+!
+!--       Create NetCDF4 files for parallel writing
+          DO  av = 0, 1
+!
+!--          If there is no instantaneous data (av=0) or averaged data (av=1)
+!--          requested, do not create the corresponding NetCDF file
+             IF ( dosurf_no(av) == 0 ) CYCLE
+
+             IF ( av == 0 )  THEN
+                filename = 'SURFACE_DATA_NETCDF' // TRIM( coupling_char )
+             ELSE
+                filename = 'SURFACE_DATA_AV_NETCDF' // TRIM( coupling_char )
+             ENDIF
+!
+!--          Open file using netCDF4/HDF5 format, parallel
+             nc_stat = NF90_CREATE( TRIM(filename),                            &
+                                    IOR( NF90_NOCLOBBER,                       &
+                                    IOR( NF90_NETCDF4, NF90_MPIIO ) ),         &
+                                    id_set_surf(av), COMM = comm2d, INFO = MPI_INFO_NULL )
+             CALL netcdf_handle_error( 'surface_data_output_mod', 5550 )
+
+             !- Write some global attributes
+             IF ( av == 0 )  THEN
+                CALL netcdf_create_global_atts( id_set_surf(av), 'surface-data', TRIM( run_description_header ), 5551 )
+                time_average_text = ' '
+             ELSE
+                CALL netcdf_create_global_atts( id_set_surf(av), 'surface-data_av', TRIM( run_description_header ), 5552 )
+                WRITE ( time_average_text,'(F7.1,'' s avg'')' )  averaging_interval_surf
+                nc_stat = NF90_PUT_ATT( id_set_surf(av), NF90_GLOBAL, 'time_avg',  &
+                                        TRIM( time_average_text ) )
+                CALL netcdf_handle_error( 'surface_data_output_mod', 5553 )
+             ENDIF
+
+
+!
+!--          Define time coordinate for surface data.
+!--          For parallel output the time dimension has to be limited (ntdim_surf),
+!--          otherwise the performance drops significantly.
+             CALL netcdf_create_dim( id_set_surf(av), 'time', ntdim_surf(av),  &
+                                     id_dim_time_surf(av), 5554 )
+
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_time_surf(av) /),    &
+                                     'time', NF90_DOUBLE, id_var_time_surf(av),      &
+                                     'seconds since '//TRIM(init_model%origin_time), &
+                                     'time', 5555, 5555, 5555 )
+             CALL netcdf_create_att( id_set_surf(av), id_var_time_surf(av), 'standard_name', 'time', 5556)
+             CALL netcdf_create_att( id_set_surf(av), id_var_time_surf(av), 'axis', 'T', 5557)
+!
+!--          Define spatial dimensions and coordinates:
+!--          Define index of surface element
+             CALL netcdf_create_dim( id_set_surf(av), 's', surfaces%ns_total,  &
+                                     id_dim_s_surf(av), 5558 )
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /), &
+                                     's', NF90_DOUBLE, id_var_s_surf(av),      &
+                                     '1', '', 5559, 5559, 5559 )
+!
+!--          Define x coordinate
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /), &
+                                     'xs', NF90_DOUBLE, id_var_xs_surf(av),    &
+                                     'meters', '', 5561, 5561, 5561 )
+!
+!--           Define y coordinate
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /), &
+                                     'ys', NF90_DOUBLE, id_var_ys_surf(av),    &
+                                     'meters', '', 5562, 5562, 5562 )
+!
+!--          Define z coordinate
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /), &
+                                     'zs', NF90_DOUBLE, id_var_zs_surf(av),    &
+                                     'meters', '', 5560, 5560, 5560 )
+
+!
+!--          Define UTM coordinates
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /),    &
+                                     'Es_UTM', NF90_DOUBLE, id_var_etum_surf(av), &
+                                     'meters', '', 5563, 5563, 5563 )
+             CALL netcdf_create_var( id_set_surf(av), (/ id_dim_s_surf(av) /),    &
+                                     'Ns_UTM', NF90_DOUBLE, id_var_nutm_surf(av), &
+                                     'meters', '', 5564, 5564, 5564 )
+!
+!--          Define the variables
+             var_list = ';'
+             i = 1
+
+             DO WHILE ( dosurf(av,i)(1:1) /= ' ' )
+
+                CALL netcdf_create_var( id_set_surf(av),(/ id_dim_s_surf(av),  &
+                                        id_dim_time_surf(av) /), dosurf(av,i), &
+                                        NF90_REAL4, id_var_dosurf(av,i),       &
+                                        dosurf_unit(av,i), dosurf(av,i), 5565, &
+                                        5565, 5565, .TRUE. )
+!
+!--                Set no fill for every variable to increase performance.
+                nc_stat = NF90_DEF_VAR_FILL( id_set_surf(av),     &
+                                             id_var_dosurf(av,i), &
+                                             1, 0 )
+                CALL netcdf_handle_error( 'surface_data_output_init', 5566 )
+!
+!--                Set collective io operations for parallel io
+                nc_stat = NF90_VAR_PAR_ACCESS( id_set_surf(av),     &
+                                               id_var_dosurf(av,i), &
+                                               NF90_COLLECTIVE )
+                CALL netcdf_handle_error( 'surface_data_output_init', 5567 )
+                var_list = TRIM( var_list ) // TRIM( dosurf(av,i) ) // ';'
+
+                i = i + 1
+
+             ENDDO
+!
+!--          Write the list of variables as global attribute (this is used by
+!--          restart runs and by combine_plot_fields)
+             nc_stat = NF90_PUT_ATT( id_set_surf(av), NF90_GLOBAL, 'VAR_LIST', &
+                                     var_list )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5568 )
+
+!
+!--          Set general no fill, otherwise the performance drops significantly for
+!--          parallel output.
+             nc_stat = NF90_SET_FILL( id_set_surf(av), NF90_NOFILL, oldmode )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5569 )
+
+!
+!--          Leave netCDF define mode
+             nc_stat = NF90_ENDDEF( id_set_surf(av) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5570 )
+
+!
+!--          These data are only written by PE0 for parallel output to increase
+!--          the performance.
+             IF ( myid == 0 )  THEN
+!
+!--             Write data for surface indices
+                ALLOCATE( netcdf_data_1d(1:surfaces%ns_total) )
+
+                DO  i = 1, surfaces%ns_total
+                   netcdf_data_1d(i) = i
+                ENDDO
+
+                nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_s_surf(av),  &
+                                        netcdf_data_1d, start = (/ 1 /),     &
+                                        count = (/ surfaces%ns_total /) )
+                CALL netcdf_handle_error( 'surface_data_output_init', 5571 )
+
+                DEALLOCATE( netcdf_data_1d )
+
+             ENDIF
+
+!
+!--          Write surface positions to file
+             nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_xs_surf(av),      &
+                                     surfaces%xs, start = (/ surfaces%s(1) /), &
+                                     count = (/ surfaces%ns /) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5572 )
+
+             nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_ys_surf(av),      &
+                                     surfaces%ys, start = (/ surfaces%s(1) /), &
+                                     count = (/ surfaces%ns /) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5573 )
+
+             nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_zs_surf(av),      &
+                                     surfaces%zs, start = (/ surfaces%s(1) /), &
+                                     count = (/ surfaces%ns /) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5574 )
+
+             nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_etum_surf(av),        &
+                                     surfaces%es_utm, start = (/ surfaces%s(1) /), &
+                                     count = (/ surfaces%ns /) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5575 )
+
+             nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_nutm_surf(av),        &
+                                     surfaces%ns_utm, start = (/ surfaces%s(1) /), &
+                                     count = (/ surfaces%ns /) )
+             CALL netcdf_handle_error( 'surface_data_output_init', 5576 )
+             
+          ENDDO
+#endif
+
+       ENDIF
 
    END SUBROUTINE surface_data_output_init
